<template>
  <div>
    <headerr back class="border-b bg-white">
      <inputt
        ref="searchinput"
        iclass="border-none"
        class="inline-flex w-full"
        @input="setQuery($event)"
        :value="query"
        placeholder="Search your tasks"
        type="text"
      ></inputt>
      <template v-slot:right>
        <i
          v-if="query.length > 0"
          @click="
            setQuery('');
            focus();
          "
          class="hero x solid text-grey-darker cursor-pointer"
        ></i>
      </template>
    </headerr>
    <div class="container mx-auto pb-32">
      <search-query-results thin :value="query" class="mx-2" />
    </div>
  </div>
</template>

<script lang="ts">
import Inputt from "@/components/Inputt.vue";
import SearchQueryResults from "@/components/Search/SearchQueryResults.vue";
import { onMounted, ref } from "vue";
import router from "@/router";
import Task from "@/models/Task";

export default {
  components: { Inputt, SearchQueryResults },
  props: {
    query: {
      type: String,
      required: true,
      default: ""
    }
  },
  setup(props) {
    const searchinput = ref<HTMLElement | null>(null);
    const focus = () => searchinput.value!.focus();
    onMounted(focus);

    return {
      searchinput,
      focus,
      setQuery: (query: string) => router.replace({ name: "SearchQuery", params: { query } }),
      resultClick: (task: Task) => {
        if (task.id) {
          router.push({ name: "Task", params: { task: task.id.toString() } });
        }
      }
    };
  }
};
</script>
